Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ExecExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ExecExpressions.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ExecExpressions.cs	(revision 14602)
@@ -1,55 +1,80 @@
-﻿namespace HeuristicLab.Algorithms.PushGP.Expressions {
+﻿using System.Threading;
+
+namespace HeuristicLab.Algorithms.PushGP.Expressions {
   using System;
   using System.Collections.Generic;
+  using System.Diagnostics;
   using System.Linq;
   using System.Text;
-  using HeuristicLab.Algorithms.PushGP.Interpreter;
-
-  public class ExecExpandExpression : StatefullExpression<Expression[]> {
-    private const string PREFIX = "( ";
-    private const string POSTFIX = ")";
-    private const string DELIMITER = " ";
-
+  using Interpreter;
+
+  public class ExecExpandExpression : WrapperExpression<Expression[]> {
+    private const string Prefix = "( ";
+    private const string PrefixReduced = "[";
+    private const string Postfix = ")";
+    private const string PostfixReduced = "]";
+    private const string Delimiter = " ";
+
+    public static readonly ExecExpandExpression Empty = new ExecExpandExpression();
+
+    private readonly Lazy<string> _stringValue;
+    private readonly int[] _treeIndex;
     public readonly int Depth;
 
-    public static readonly ExecExpandExpression Empty = new ExecExpandExpression(new Expression[0]);
+    private readonly int _hashCode;
+
+    public ExecExpandExpression(params Expression[] state) : base(state) {
+      IsEmpty = State.Length == 0;
+
+      Depth = CalcDepth();
+      _treeIndex = BuildTreeIndex();
+      _hashCode = HashExpressions();
+
+      _stringValue = new Lazy<string>(BuildString, LazyThreadSafetyMode.ExecutionAndPublication);
+    }
+
+    public ExecExpandExpression(IEnumerable<Expression> state) : this(state.ToArray()) {
+      // TODO: lazy evaluation of ToArray()
+    }
+
+#if DEBUG
+
+    private static void CheckIfNested(int level, ExecExpandExpression target, ExecExpandExpression current,
+        IList<ExecExpandExpression> visited) {
+      if (visited.Any(x => ReferenceEquals(x, current)))
+        Debugger.Break();
+
+      visited.Add(current);
+      if (level <= 0) {
+        // hirarchy depth > level
+        Debugger.Break();
+        return;
+      }
+
+      for (var i = 0; i < current.State.Length; i++) {
+        if (current.State[i].GetType() != typeof(ExecExpandExpression))
+          continue;
+
+        var subExpression = current.State[i] as ExecExpandExpression;
+
+        if (ReferenceEquals(target, subExpression)) {
+          // Endless recursion dedected
+          Debugger.Break();
+        }
+
+        CheckIfNested(level - 1, target, subExpression, visited);
+      }
+
+      visited.RemoveAt(visited.Count - 1);
+    }
+
+#endif
+
+    public IReadOnlyList<Expression> Expressions
+    {
+      get { return State; }
+    }
 
     public bool IsEmpty { get; private set; }
-
-    private int[] treeIndex;
-
-    public ExecExpandExpression(Expression[] state)
-      : base(state) {
-      this.IsEmpty = this.State.Length == 0;
-      this.InitId();
-
-      var subExpressions = state.Where(e => e.GetType() == typeof(ExecExpandExpression));
-
-      this.Depth = subExpressions.Any() ? subExpressions.Select(e => e as ExecExpandExpression).Max(e => e.Depth) : 1;
-    }
-
-    //private void CheckIfNested(int level, Expression parent)
-    //{
-    //    for (var i = 0; i < State.Length; i++)
-    //    {
-    //        if (State[i].GetType() == typeof(ExecExpandExpression))
-    //        {
-    //            if (parent == State[i])
-    //            {
-    //                Debugger.Break();
-    //            }
-
-    //            (State[i] as ExecExpandExpression).CheckIfNested(level + 1, parent);
-    //        }
-    //    }
-    //}
-
-    public ExecExpandExpression(ExecExpandExpression origin) : base(new Expression[origin.State.Length]) {
-      Array.Copy(origin.State, this.State, origin.State.Length);
-
-      this.IsEmpty = origin.IsEmpty;
-    }
-
-    public IReadOnlyList<Expression> Expressions { get { return this.State; } }
 
     /// <summary>
@@ -61,69 +86,85 @@
       get
       {
-        if (this.IsEmpty) {
-          return 1;
-        }
-
-        this.BuildIndexIfNecessary();
-
-        // + 1 because this is also counted
-        return this.treeIndex[0] + 1;
-      }
-    }
-
-    protected override string InitStringRepresentation() {
-      var sb = new StringBuilder();
-
-      sb.Append(PREFIX);
-#if DEBUG
-      for (var i = this.State.Length - 1; i >= 0; i--)
-        sb.Append(this.State[i] + DELIMITER);
-#else
-      sb.Append(this.TotalCount.ToString() + DELIMITER);
-#endif
-
-      sb.Append(POSTFIX);
-
-      return sb.ToString();
-    }
-
-    protected sealed override int InitId() {
+        return IsEmpty
+            ? 1
+            // + 1 because this is also counted
+            : _treeIndex[0] + 1;
+      }
+    }
+
+    public override string ToString() {
+      return _stringValue.Value;
+    }
+
+    private int HashExpressions() {
       var hash = 19 * 31 + this.GetType().GetHashCode();
 
-      for (var i = this.State.Length - 1; i >= 0; i--) hash = hash * 31 + this.State[i].GetHashCode();
+      for (var i = 0; i < this.State.Length; i++) {
+        hash = hash * 31 + this.State[i].GetHashCode();
+      }
 
       return hash;
+    }
+
+    protected override int CalcHashCode() {
+      return _hashCode;
     }
 
     public ExecExpandExpression Copy() {
       // as the empty list is a static stateless expression, no copy required
-      return this == Empty || this.IsEmpty
-        ? Empty
-        : new ExecExpandExpression(this.State);
+      return this == Empty || IsEmpty ? Empty : new ExecExpandExpression(State);
     }
 
     public Expression[] CopyExpressions() {
-      var copy = new Expression[this.State.Length];
-      Array.Copy(this.State, copy, this.State.Length);
+      var copy = new Expression[State.Length];
+      Array.Copy(State, copy, State.Length);
 
       return copy;
     }
 
-    public override int GetHashCode() {
-      return base.GetHashCode();
-    }
-
-    public override string ToString() {
-      return this.StringRepresentation;
-    }
-
-    public override bool Equals(object obj) {
-      if ((obj == null) || (obj.GetType() != typeof(ExecExpandExpression))) return false;
-
-      return this.GetHashCode() == obj.GetHashCode();
-    }
-
-    public override void Eval(IPushGpInterpreter interpreter) {
-      interpreter.ExecStack.Push(this.State);
+    public override void Eval(IPushGpInterpreter interpreter) {
+      interpreter.ExecStack.Push(State);
+    }
+
+    private int CalcDepth() {
+      var subExpressions = State.Where(e => e.GetType() == typeof(ExecExpandExpression));
+      var depth = subExpressions.Any()
+          ? subExpressions.Select(e => e as ExecExpandExpression).Max(e => e.Depth) + 1
+          : 1;
+
+      return depth;
+    }
+
+    private string BuildString() {
+      // prevent stack overflow
+      if (this.TotalCount > 50)
+        return PrefixReduced + this.State.Length + PostfixReduced;
+
+      var sb = new StringBuilder();
+
+      sb.Append(Prefix);
+      for (var i = this.State.Length - 1; i >= 0; i--) sb.Append(this.State[i] + Delimiter);
+      sb.Append(Postfix);
+      return sb.ToString();
+    }
+
+    private int[] BuildTreeIndex() {
+      var treeIndex = new int[State.Length];
+
+      var next = 1;
+
+      for (var i = State.Length - 1; i >= 0; i--) {
+        var subExpression = State[i];
+
+        treeIndex[i] = next;
+
+        if (subExpression.GetType() == typeof(ExecExpandExpression)) {
+          next += (subExpression as ExecExpandExpression).TotalCount;
+        } else {
+          next++;
+        }
+      }
+
+      return treeIndex;
     }
 
@@ -134,23 +175,23 @@
     /// <returns>The required element</returns>
     public Expression GetFromTree(int index) {
-      return this.GetFromTree(index, (root, parent, child, childIndex, parentIndex) => child);
+      return GetFromTree(index, (root, parent, child, childIndex, parentIndex) => child);
     }
 
     /// <returns>The required element</returns>
-    public T GetFromTree<T>(int index, Func<ExecExpandExpression, ExecExpandExpression, Expression, int, int, T> resolver) {
-      return this.GetFromTree(index, 0, null, resolver);
-    }
-
-    private T GetFromTree<T>(int index, int parentIndex, ExecExpandExpression parent, Func<ExecExpandExpression, ExecExpandExpression, Expression, int, int, T> resolver) {
+    public T GetFromTree<T>(int index,
+        Func<ExecExpandExpression, ExecExpandExpression, Expression, int, int, T> resolver) {
+      return GetFromTree(index, 0, null, resolver);
+    }
+
+    private T GetFromTree<T>(int index, int parentIndex, ExecExpandExpression parent,
+        Func<ExecExpandExpression, ExecExpandExpression, Expression, int, int, T> resolver) {
       if (index == 0) return resolver(parent, parent, this, 0, parentIndex);
 
-      this.BuildIndexIfNecessary();
-
-      var min = this.State.Length - 1;
+      var min = State.Length - 1;
       var max = 0;
       var mid = (min + max) / 2;
 
-      while ((max <= min) && (this.treeIndex[mid] != index)) {
-        if (this.treeIndex[mid] > index) max = mid + 1;
+      while ((max <= min) && (_treeIndex[mid] != index)) {
+        if (_treeIndex[mid] > index) max = mid + 1;
         else min = mid - 1;
 
@@ -158,31 +199,8 @@
       }
 
-      return this.treeIndex[mid] == index
-        ? resolver(parent, this, this.State[mid], mid, parentIndex)
-        : (this.State[mid + 1] as ExecExpandExpression).GetFromTree(index - this.treeIndex[mid + 1], mid + 1, this, resolver);
-    }
-
-    private void BuildIndexIfNecessary() {
-      if (this.treeIndex != null) return;
-
-      this.BuildIndex();
-    }
-
-    private void BuildIndex() {
-      this.treeIndex = new int[this.State.Length];
-
-      var next = 1;
-
-      for (var i = this.State.Length - 1; i >= 0; i--) {
-        var subExpression = this.State[i];
-
-        this.treeIndex[i] = next;
-
-        if (subExpression.GetType() == typeof(ExecExpandExpression)) {
-          next += (subExpression as ExecExpandExpression).TotalCount;
-        } else {
-          next++;
-        }
-      }
+      return _treeIndex[mid] == index
+          ? resolver(parent, this, State[mid], mid, parentIndex)
+          : (State[mid + 1] as ExecExpandExpression).GetFromTree(index - _treeIndex[mid + 1], mid + 1,
+              this, resolver);
     }
   }
@@ -195,6 +213,5 @@
   /// </summary>
   public class ExecIfExpression : StatelessExpression {
-    protected override string InitStringRepresentation() {
-      return "EXEC.IF";
+    public ExecIfExpression() : base("EXEC.IF") {
     }
 
@@ -215,6 +232,5 @@
   /// </summary>
   public class ExecYExpression : StatelessExpression {
-    protected override string InitStringRepresentation() {
-      return "EXEC.Y";
+    public ExecYExpression() : base("EXEC.Y") {
     }
 
@@ -224,5 +240,5 @@
 
       var top = interpreter.ExecStack.Top;
-      var result = new ExecExpandExpression(new[] { top, new ExecYExpression() });
+      var result = new ExecExpandExpression(top, new ExecYExpression());
 
       interpreter.ExecStack.Insert(interpreter.ExecStack.Count - 1, result);
@@ -234,6 +250,5 @@
   /// </summary>
   public class ExecKExpression : StatelessExpression {
-    protected override string InitStringRepresentation() {
-      return "EXEC.K";
+    public ExecKExpression() : base("EXEC.K") {
     }
 
@@ -252,6 +267,5 @@
   /// </summary>
   public class ExecSExpression : StatelessExpression {
-    protected override string InitStringRepresentation() {
-      return "EXEC.S";
+    public ExecSExpression() : base("EXEC.S") {
     }
 
@@ -259,10 +273,10 @@
       if (interpreter.ExecStack.Count < 3) return;
 
-      var State = interpreter.ExecStack.Pop(2);
-      var a = State[1];
-      var b = State[0];
+      var expression = interpreter.ExecStack.Pop(2);
+      var a = expression[1];
+      var b = expression[0];
       var c = interpreter.ExecStack.Top;
 
-      var newTop = new ExecExpandExpression(new[] { c, b });
+      var newTop = new ExecExpandExpression(c, b);
 
       interpreter.ExecStack.SetTop(newTop);
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Expression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Expression.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Expression.cs	(revision 14602)
@@ -4,35 +4,16 @@
 
   public abstract class Expression {
-    protected int id;
-    protected string stringRepresentation;
+    private readonly string stringRepresentation;
 
-    public string StringRepresentation
-    {
-      get { return this.stringRepresentation ?? (this.stringRepresentation = this.InitStringRepresentation()); }
+    protected Expression(string stringRepresentation) {
+      this.stringRepresentation = stringRepresentation;
     }
 
-    public int Id
-    {
-      get
-      {
-        if (this.id == default(int))
-          this.id = this.InitId();
-
-        return this.id;
-      }
-    }
+    public string StringRepresentation { get { return this.stringRepresentation; } }
 
     public abstract void Eval(IPushGpInterpreter interpreter);
 
-    protected abstract int InitId();
-
-    protected abstract string InitStringRepresentation();
-
-    public override bool Equals(object obj) {
-      return (obj != null) && ((this.GetHashCode() == obj.GetHashCode()) || (this.GetType() == obj.GetType()));
-    }
-
-    public override int GetHashCode() {
-      return this.Id;
+    public override string ToString() {
+      return this.stringRepresentation;
     }
   }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ExpressionTable.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ExpressionTable.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ExpressionTable.cs	(revision 14602)
@@ -5,7 +5,9 @@
 
   public static class ExpressionTable {
-    private static readonly Dictionary<string, Expression> statelessExpressionTable;
+    private static readonly IDictionary<string, Expression> statelessExpressionTable;
+    private static readonly IDictionary<string, Func<Expression>> statefullExpressionFactory;
 
-    private static readonly Dictionary<string, Func<Expression>> statefullExpressionFactory;
+    private static readonly IDictionary<int, string> indexToNameTable = new Dictionary<int, string>();
+
 
     public static int Count;
@@ -43,4 +45,5 @@
 
         dictionary.Add(key, expression);
+        indexToNameTable.Add(indexToNameTable.Keys.Count, key);
       }
 
@@ -63,4 +66,5 @@
 
         dictionary.Add(key, creator);
+        indexToNameTable.Add(indexToNameTable.Keys.Count, key);
       }
 
@@ -102,8 +106,21 @@
 
     public static Expression GetExpression(int index) {
+      var name = indexToNameTable[index];
+      return GetExpression(name);
+
       // TODO: build lookup table for index to determine the key for the dictionary (get rid of ElementAt, is it slow?)
-      return index < StatelessCount
-               ? statelessExpressionTable.ElementAt(index).Value
-               : statefullExpressionFactory.ElementAt(index - StatelessCount).Value();
+      //return index < StatelessCount
+      //         ? statelessExpressionTable.ElementAt(index).Value
+      //         : statefullExpressionFactory.ElementAt(index - StatelessCount).Value();
+    }
+
+    public static ExecExpandExpression GetProgram(int[] index) {
+      var expressions = new List<Expression>(index.Length);
+
+      for (var i = 0; i < index.Length; i++) {
+        expressions.Add(GetExpression(index[i]));
+      }
+
+      return new ExecExpandExpression(expressions);
     }
 
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/FloatExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/FloatExpressions.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/FloatExpressions.cs	(revision 14602)
@@ -1,228 +1,214 @@
 ﻿namespace HeuristicLab.Algorithms.PushGP.Expressions
 {
-  using System;
-
-  using HeuristicLab.Algorithms.PushGP.Interpreter;
-
-  /// <summary>
-  ///     Pushes the sum of the top two items.
-  /// </summary>
-  public class FloatAddExpression : PushResultExpression<double>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "FLOAT.+";
-    }
-
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
-      this.Eval(interpreter.FloatStack, 2, values => values[0] + values[1]);
-    }
-  }
-
-  /// <summary>
-  ///     Pushes the difference of the top two items; that is, the second item minus the top item.
-  /// </summary>
-  public class FloatSubtractExpression : PushResultExpression<double>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "FLOAT.-";
-    }
-
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
-      this.Eval(interpreter.FloatStack, 2, values => values[0] - values[1]);
-    }
-  }
-
-  /// <summary>
-  ///     Pushes the product of the top two items.
-  /// </summary>
-  public class FloatMultiplyExpression : PushResultExpression<double>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "FLOAT.*";
-    }
-
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
-      this.Eval(interpreter.FloatStack, 2, values => values[0] * values[1]);
-    }
-  }
-
-  /// <summary>
-  ///     Pushes the quotient of the top two items; that is, the second item divided by the top item.
-  ///     If the top item is zero this acts as a NOOP.
-  /// </summary>
-  public class FloatDivideExpression : PushResultExpression<double>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "FLOAT./";
-    }
-
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
-      this.Eval(interpreter.FloatStack, 2, values => values[0] / values[1], 0);
-    }
-  }
-
-  /// <summary>
-  ///     Pushes the second stack item modulo the top stack item. If the top item is zero this acts as a NOOP.
-  ///     The modulus is computed as the remainder of the quotient, where the quotient has first been truncated toward
-  ///     negative infinity.
-  ///     (This is taken from the definition for the generic MOD function in Common Lisp, which is described
-  ///     for example at http://www.lispworks.com/reference/HyperSpec/Body/f_mod_r.htm.)
-  /// </summary>
-  public class FloatModuloExpression : PushResultExpression<double>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "FLOAT.%";
-    }
-
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
-      this.Eval(interpreter.FloatStack, 2, values => values[0] % values[1], 0);
-    }
-  }
-
-  /// <summary>
-  ///     Pushes the minimum of the top two items.
-  /// </summary>
-  public class FloatMinExpression : PushResultExpression<double>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "FLOAT.MIN";
-    }
-
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
-      this.Eval(interpreter.FloatStack, 2, values => Math.Min(values[0], values[1]));
-    }
-  }
-
-  /// <summary>
-  ///     Pushes the maximum of the top two items.
-  /// </summary>
-  public class FloatMaxExpression : PushResultExpression<double>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "FLOAT.MAX";
-    }
-
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
-      this.Eval(interpreter.FloatStack, 2, values => Math.Max(values[0], values[1]));
-    }
-  }
-
-  /// <summary>
-  ///     Pushes TRUE onto the BOOLEAN stack if the second item is less than the top item, or FALSE otherwise.
-  /// </summary>
-  public class FloatSmallerThanExpression : PushResultExpression<double>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "FLOAT.<";
-    }
-
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
-      this.Eval(interpreter.FloatStack, interpreter.BooleanStack, 2, values => values[0] < values[1]);
-    }
-  }
-
-  /// <summary>
-  ///     Pushes TRUE onto the BOOLEAN stack if the second item is greater than the top item, or FALSE otherwise.
-  /// </summary>
-  public class FloatGreaterThanExpression : PushResultExpression<double>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "FLOAT.>";
-    }
-
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
-      this.Eval(interpreter.FloatStack, interpreter.BooleanStack, 2, values => values[0] > values[1]);
-    }
-  }
-
-  /// <summary>
-  ///     Pushes the sine of the top item.
-  /// </summary>
-  public class FloatSineExpression : PushResultExpression<double>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "FLOAT.SIN";
-    }
-
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
-      this.Eval(interpreter.FloatStack, 1, values => Math.Sin(values[0]));
-    }
-  }
-
-  /// <summary>
-  ///     Pushes the cosine of the top item.
-  /// </summary>
-  public class FloatCosineExpression : PushResultExpression<double>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "FLOAT.COS";
-    }
-
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
-      this.Eval(interpreter.FloatStack, 1, values => Math.Cos(values[0]));
-    }
-  }
-
-  /// <summary>
-  ///     Pushes 1 if the top BOOLEAN is TRUE, or 0 if the top BOOLEAN is FALSE.
-  /// </summary>
-  public class FloatFromBooleanExpression : StatelessExpression
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "FLOAT.FROMBOOLEAN";
-    }
-
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
-      if (interpreter.BooleanStack.Count == 0) return;
-
-      var condition = interpreter.BooleanStack.Pop();
-      var value = condition ? 1 : 0;
-
-      interpreter.FloatStack.Push(value);
-    }
-  }
-
-  /// <summary>
-  ///     Pushes a floating point version of the top INTEGER.
-  /// </summary>
-  public class FloatFromIntegerExpression : StatelessExpression
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "FLOAT.FROMINTEGER";
-    }
-
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
-      if (interpreter.IntegerStack.Count == 0) return;
-
-      var value = (double)interpreter.IntegerStack.Pop();
-
-      interpreter.FloatStack.Push(value);
-    }
-  }
+    using System;
+    using HeuristicLab.Algorithms.PushGP.Interpreter;
+
+    /// <summary>
+    ///     Pushes the sum of the top two items.
+    /// </summary>
+    public class FloatAddExpression : PushResultExpression<double>
+    {
+        public FloatAddExpression() : base("FLOAT.+")
+        {
+        }
+
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Eval(interpreter.FloatStack, 2, values => values[0] + values[1]);
+        }
+    }
+
+    /// <summary>
+    ///     Pushes the difference of the top two items; that is, the second item minus the top item.
+    /// </summary>
+    public class FloatSubtractExpression : PushResultExpression<double>
+    {
+        public FloatSubtractExpression() : base("FLOAT.-")
+        {
+        }
+
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.FloatStack, 2, values => values[0] - values[1]);
+        }
+    }
+
+    /// <summary>
+    ///     Pushes the product of the top two items.
+    /// </summary>
+    public class FloatMultiplyExpression : PushResultExpression<double>
+    {
+        public FloatMultiplyExpression() : base("FLOAT.*")
+        {
+        }
+
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.FloatStack, 2, values => values[0] * values[1]);
+        }
+    }
+
+    /// <summary>
+    ///     Pushes the quotient of the top two items; that is, the second item divided by the top item.
+    ///     If the top item is zero this acts as a NOOP.
+    /// </summary>
+    public class FloatDivideExpression : PushResultExpression<double>
+    {
+        public FloatDivideExpression() : base("FLOAT./")
+        {
+        }
+
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.FloatStack, 2, values => values[0] / values[1], 0);
+        }
+    }
+
+    /// <summary>
+    ///     Pushes the second stack item modulo the top stack item. If the top item is zero this acts as a NOOP.
+    ///     The modulus is computed as the remainder of the quotient, where the quotient has first been truncated toward
+    ///     negative infinity.
+    ///     (This is taken from the definition for the generic MOD function in Common Lisp, which is described
+    ///     for example at http://www.lispworks.com/reference/HyperSpec/Body/f_mod_r.htm.)
+    /// </summary>
+    public class FloatModuloExpression : PushResultExpression<double>
+    {
+        public FloatModuloExpression() : base("FLOAT.%")
+        {
+        }
+
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.FloatStack, 2, values => values[0] % values[1], 0);
+        }
+    }
+
+    /// <summary>
+    ///     Pushes the minimum of the top two items.
+    /// </summary>
+    public class FloatMinExpression : PushResultExpression<double>
+    {
+        public FloatMinExpression() : base("FLOAT.MIN")
+        {
+        }
+
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.FloatStack, 2, values => Math.Min(values[0], values[1]));
+        }
+    }
+
+    /// <summary>
+    ///     Pushes the maximum of the top two items.
+    /// </summary>
+    public class FloatMaxExpression : PushResultExpression<double>
+    {
+        public FloatMaxExpression() : base("FLOAT.MAX")
+        {
+        }
+
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.FloatStack, 2, values => Math.Max(values[0], values[1]));
+        }
+    }
+
+    /// <summary>
+    ///     Pushes TRUE onto the BOOLEAN stack if the second item is less than the top item, or FALSE otherwise.
+    /// </summary>
+    public class FloatSmallerThanExpression : PushResultExpression<double>
+    {
+        public FloatSmallerThanExpression() : base("FLOAT.<")
+        {
+        }
+
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.FloatStack, interpreter.BooleanStack, 2, values => values[0] < values[1]);
+        }
+    }
+
+    /// <summary>
+    ///     Pushes TRUE onto the BOOLEAN stack if the second item is greater than the top item, or FALSE otherwise.
+    /// </summary>
+    public class FloatGreaterThanExpression : PushResultExpression<double>
+    {
+        public FloatGreaterThanExpression() : base("FLOAT.>")
+        {
+        }
+
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.FloatStack, interpreter.BooleanStack, 2, values => values[0] > values[1]);
+        }
+    }
+
+    /// <summary>
+    ///     Pushes the sine of the top item.
+    /// </summary>
+    public class FloatSineExpression : PushResultExpression<double>
+    {
+        public FloatSineExpression() : base("FLOAT.SIN")
+        {
+        }
+
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.FloatStack, 1, values => Math.Sin(values[0]));
+        }
+    }
+
+    /// <summary>
+    ///     Pushes the cosine of the top item.
+    /// </summary>
+    public class FloatCosineExpression : PushResultExpression<double>
+    {
+        public FloatCosineExpression() : base("FLOAT.COS")
+        {
+        }
+
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.FloatStack, 1, values => Math.Cos(values[0]));
+        }
+    }
+
+    /// <summary>
+    ///     Pushes 1 if the top BOOLEAN is TRUE, or 0 if the top BOOLEAN is FALSE.
+    /// </summary>
+    public class FloatFromBooleanExpression : StatelessExpression
+    {
+        public FloatFromBooleanExpression() : base("FLOAT.FROMBOOLEAN")
+        {
+        }
+
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            if (interpreter.BooleanStack.Count == 0) return;
+
+            var condition = interpreter.BooleanStack.Pop();
+            var value = condition ? 1 : 0;
+
+            interpreter.FloatStack.Push(value);
+        }
+    }
+
+    /// <summary>
+    ///     Pushes a floating point version of the top INTEGER.
+    /// </summary>
+    public class FloatFromIntegerExpression : StatelessExpression
+    {
+        public FloatFromIntegerExpression() : base("FLOAT.FROMINTEGER")
+        {
+        }
+
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            if (interpreter.IntegerStack.Count == 0) return;
+
+            var value = (double) interpreter.IntegerStack.Pop();
+
+            interpreter.FloatStack.Push(value);
+        }
+    }
 }
